﻿// Egy hexadecimális számjegy kijelzése
// Egy frekvenciaosztó számláló felhasználásával egy számjegyet íratunk ki 0-tól F-ig.
module display (clk_50M, digit, segment);

input clk_50M;                         // 50MHz órajel (pin12)
output wire [7:0] digit;               // számjegyek vezérlése
output reg [7:0] segment;              // DP és gfedcba szegmensek vezérlése

reg [27:0] count;                      // frekvencia-osztó számláló

assign digit = 8'b11111110;            // digital tube bit selection is on

always @ (posedge clk_50M)             // frekvencia leosztás
 begin
  count <= count + 1;                  // számláló léptetése
 end

always @ (negedge count[23])
 begin
  case (count [27:24])                 // A frekcenciaosztó felső bitjei
   0: segment <= 8'b11000000;          // Közös anódú szegmensek - negatív logika  
   1: segment <= 8'b11111001;
   2: segment <= 8'b10100100;
   3: segment <= 8'b10110000;
   4: segment <= 8'b10011001;
   5: segment <= 8'b10010010;
   6: segment <= 8'b10000010;
   7: segment <= 8'b11111000;
   8: segment <= 8'b10000000;
   9: segment <= 8'b10010000;
  10: segment <= 8'b10001000;
  11: segment <= 8'b10000011;
  12: segment <= 8'b11000110;
  13: segment <= 8'b10100001;
  14: segment <= 8'b10000110;
  15: segment <= 8'b10001110;
  endcase
 end
endmodule